#ifndef RESULTS_H
#define RESULTS_H
#include "graphs.h"
#include "message.h"
#include "xmloutput.h"
//#define CONTROLDIR "/var/qmail/control/"
#include "data.h"
#include "config.h"
#include "stuff.h"

class Results {
  protected:
    MHandler *messages;
    Images *images;
    Config *config;
    
  private:
    struct tm *firstmsg;
    struct tm *lastmsg;
    Domains *dWurzel;		// die wurzel auf die Domain struktur
    LDomains *ldWurzel;		// die localen domains
    Domains *adddomain();	// fgt eine neue domain der Struktur hinzu
    Members *addmember();  	// Fgt der Domain ein neues Mitglied hinzu
    void splitemail (char *dname,char *name,char *email);
    Domains *getdomain (char *dname,LDomains *ldomain);
    Members *getmember(Domains *domain,char *name);
    void AddMessageToDomain (Domains *domain,Message *message);
    char *cleanname (char *name,LDomains *domain);
  public:
    // Konstruktor und destruktor
    Results(MHandler *messages_p,Images *images,Config *config_p);
    ~Results ();
    
    int anzmessages();
    int anzdeliveries();
    struct tm * firstmessage();
    struct tm * lastmessage();
    int diffdays();
    int diffhours();
    int diffminutes();
    int diffseconds();
    int absdiffsec();
    float emailspersecond();
    int emailintervall();
    int perhour (time_t startzeit);
    void indexhours ();
    int d_perhour (time_t startzeit);
    int permonth (time_t startmonth,Domains *domain);
    unsigned long bytespermonth (time_t startmonth,Domains *domain);
    char *indexmonth (Domains *domain);
    void ordne_zu ();
    void load_virtual_domains ();	// liest das virtualdomains file
    void save_results (XMLOutput *xmloutput);
    Domains *AddDomain (char *domainname,unsigned long anzahlm,unsigned long incoming,unsigned long outgoing,unsigned long incbytes,unsigned long outbytes,unsigned long local,unsigned long localbytes,unsigned long anzahld,unsigned long bytes,unsigned long sec,struct tm *start,struct tm *end,unsigned long usage[12],unsigned long monthbytes[12]);
    void AddMember (Domains *domain,char *name,unsigned long anzahlm,unsigned long incoming,unsigned long outgoing,unsigned long incbytes,unsigned long outbytes,unsigned long local,unsigned long localbytes,unsigned long anzahld,unsigned long bytes,unsigned long sec,struct tm *start,struct tm *end);
    void ChangeUsage (Domains *domain,unsigned long usage[12],unsigned long bytes[12]);
};

#endif
